Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 74430)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -3889,20 +3908,24 @@
     InitializeListHead(&Vcb->dirty_fcbs);
     InitializeListHead(&Vcb->dirty_filerefs);
     
-    KeInitializeSpinLock(&Vcb->dirty_fcbs_lock);
-    KeInitializeSpinLock(&Vcb->dirty_filerefs_lock);
-    
     InitializeListHead(&Vcb->DirNotifyList);
+    InitializeListHead(&Vcb->scrub.errors);
 
     FsRtlNotifyInitializeSync(&Vcb->NotifySync);
     
     ExInitializePagedLookasideList(&Vcb->tree_data_lookaside, NULL, NULL, 0, sizeof(tree_data), ALLOC_TAG, 0);
     ExInitializePagedLookasideList(&Vcb->traverse_ptr_lookaside, NULL, NULL, 0, sizeof(traverse_ptr), ALLOC_TAG, 0);
-    ExInitializePagedLookasideList(&Vcb->rollback_item_lookaside, NULL, NULL, 0, sizeof(rollback_item), ALLOC_TAG, 0);
     ExInitializePagedLookasideList(&Vcb->batch_item_lookaside, NULL, NULL, 0, sizeof(batch_item), ALLOC_TAG, 0);
+    ExInitializePagedLookasideList(&Vcb->fileref_lookaside, NULL, NULL, 0, sizeof(file_ref), ALLOC_TAG, 0);
+    ExInitializePagedLookasideList(&Vcb->fcb_lookaside, NULL, NULL, 0, sizeof(fcb), ALLOC_TAG, 0);
+    ExInitializePagedLookasideList(&Vcb->name_bit_lookaside, NULL, NULL, 0, sizeof(name_bit), ALLOC_TAG, 0);
     ExInitializeNPagedLookasideList(&Vcb->range_lock_lookaside, NULL, NULL, 0, sizeof(range_lock), ALLOC_TAG, 0);
+    ExInitializeNPagedLookasideList(&Vcb->fileref_np_lookaside, NULL, NULL, 0, sizeof(file_ref_nonpaged), ALLOC_TAG, 0);
+    ExInitializeNPagedLookasideList(&Vcb->fcb_np_lookaside, NULL, NULL, 0, sizeof(fcb_nonpaged), ALLOC_TAG, 0);
     init_lookaside = TRUE;
     
+    Vcb->Vpb = IrpSp->Parameters.MountVolume.Vpb;
+    
     Status = load_chunk_root(Vcb, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("load_chunk_root returned %08x\n", Status);
@@ -3940,15 +3963,6 @@
             if (Vcb->readonly)
                 WARN("setting volume to readonly\n");
         }
-        
-        if (!raid_generations_okay(Vcb)) {
-            ERR("could not mount as generation mismatch\n");
-            
-            IoRaiseInformationalHardError(IO_ERR_INTERNAL_ERROR, NULL, NULL);
-
-            Status = STATUS_INTERNAL_ERROR;
-            goto exit;
-        }
     } else {
         if (dev->readonly) {
             WARN("setting volume to readonly as device is readonly\n");
@@ -3956,7 +3970,7 @@
         }
     }
     
-    add_root(Vcb, BTRFS_ROOT_ROOT, Vcb->superblock.root_tree_addr, NULL);
+    add_root(Vcb, BTRFS_ROOT_ROOT, Vcb->superblock.root_tree_addr, Vcb->superblock.generation - 1, NULL);
     
     if (!Vcb->root_root) {
         ERR("Could not load root of roots.\n");
@@ -3979,8 +3993,12 @@
     InitializeListHead(&batchlist);
     
     // We've already increased the generation by one
-    if (!Vcb->readonly && Vcb->superblock.generation - 1 != Vcb->superblock.cache_generation) {
-        WARN("generation was %llx, free-space cache generation was %llx; clearing cache...\n", Vcb->superblock.generation - 1, Vcb->superblock.cache_generation);
+    if (!Vcb->readonly && (Vcb->superblock.generation - 1 != Vcb->superblock.cache_generation || Vcb->options.clear_cache)) {
+        if (Vcb->options.clear_cache)
+            WARN("ClearCache option was set, clearing cache...\n");
+        else
+            WARN("generation was %llx, free-space cache generation was %llx; clearing cache...\n", Vcb->superblock.generation - 1, Vcb->superblock.cache_generation);
+        
         Status = clear_free_space_cache(Vcb, &batchlist, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("clear_free_space_cache returned %08x\n", Status);
@@ -3989,9 +4007,9 @@
         }
     }
     
-    commit_batch_list(Vcb, &batchlist, Irp, NULL);
+    commit_batch_list(Vcb, &batchlist, Irp);
     
-    Vcb->volume_fcb = create_fcb(NonPagedPool);
+    Vcb->volume_fcb = create_fcb(Vcb, NonPagedPool);
     if (!Vcb->volume_fcb) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
@@ -4001,7 +4019,7 @@
     Vcb->volume_fcb->Vcb = Vcb;
     Vcb->volume_fcb->sd = NULL;
     
-    root_fcb = create_fcb(NonPagedPool);
+    root_fcb = create_fcb(Vcb, NonPagedPool);
     if (!root_fcb) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
@@ -4052,9 +4070,9 @@
     
     fcb_get_sd(root_fcb, NULL, TRUE, Irp);
     
-    root_fcb->atts = get_file_attributes(Vcb, &root_fcb->inode_item, root_fcb->subvol, root_fcb->inode, root_fcb->type, FALSE, FALSE, Irp);
+    root_fcb->atts = get_file_attributes(Vcb, root_fcb->subvol, root_fcb->inode, root_fcb->type, FALSE, FALSE, Irp);
     
-    Vcb->root_fileref = create_fileref();
+    Vcb->root_fileref = create_fileref(Vcb);
     if (!Vcb->root_fileref) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
@@ -4112,7 +4130,6 @@
     NewDeviceObject->Vpb->VolumeLabel[0] = '?';
     NewDeviceObject->Vpb->VolumeLabel[1] = 0;
     NewDeviceObject->Vpb->ReferenceCount++; // FIXME - should we deref this at any point?
-    Vcb->Vpb = NewDeviceObject->Vpb;
     
     KeInitializeEvent(&Vcb->flush_thread_finished, NotificationEvent, FALSE);
     
@@ -4137,8 +4154,13 @@
         WARN("look_for_balance_item returned %08x\n", Status);
     
     Status = STATUS_SUCCESS;
+    
+    vde->mounted_device = NewDeviceObject;
+    
+exit:
+    ExReleaseResourceLite(&vde->child_lock);
 
-exit:
+exit2:
     if (Vcb) {
         ExReleaseResourceLite(&Vcb->load_lock);
     }
@@ -4148,15 +4170,19 @@
             if (init_lookaside) {
                 ExDeletePagedLookasideList(&Vcb->tree_data_lookaside);
                 ExDeletePagedLookasideList(&Vcb->traverse_ptr_lookaside);
-                ExDeletePagedLookasideList(&Vcb->rollback_item_lookaside);
                 ExDeletePagedLookasideList(&Vcb->batch_item_lookaside);
+                ExDeletePagedLookasideList(&Vcb->fileref_lookaside);
+                ExDeletePagedLookasideList(&Vcb->fcb_lookaside);
+                ExDeletePagedLookasideList(&Vcb->name_bit_lookaside);
                 ExDeleteNPagedLookasideList(&Vcb->range_lock_lookaside);
+                ExDeleteNPagedLookasideList(&Vcb->fileref_np_lookaside);
+                ExDeleteNPagedLookasideList(&Vcb->fcb_np_lookaside);
             }
                 
             if (Vcb->root_file)
                 ObDereferenceObject(Vcb->root_file);
             else if (Vcb->root_fileref)
-                free_fileref(Vcb->root_fileref);
+                free_fileref(Vcb, Vcb->root_fileref);
             else if (root_fcb)
                 free_fcb(root_fcb);
 
@@ -4167,6 +4193,9 @@
             ExDeleteResourceLite(&Vcb->load_lock);
             ExDeleteResourceLite(&Vcb->fcb_lock);
             ExDeleteResourceLite(&Vcb->chunk_lock);
+            ExDeleteResourceLite(&Vcb->dirty_fcbs_lock);
+            ExDeleteResourceLite(&Vcb->dirty_filerefs_lock);
+            ExDeleteResourceLite(&Vcb->scrub.stats_lock);
 
             if (Vcb->devices.Flink) {
                 while (!IsListEmpty(&Vcb->devices)) {
@@ -4195,17 +4224,14 @@
 
 static NTSTATUS verify_volume(PDEVICE_OBJECT devobj) {
     device_extension* Vcb = devobj->DeviceExtension;
-    ULONG cc, to_read;
-    IO_STATUS_BLOCK iosb;
+    ULONG cc;
     NTSTATUS Status;
-    superblock* sb;
-    UINT32 crc32;
     LIST_ENTRY* le;
     
     if (Vcb->removing)
         return STATUS_WRONG_VOLUME;
     
-    Status = dev_ioctl(Vcb->Vpb->RealDevice, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
+    Status = dev_ioctl(Vcb->Vpb->RealDevice, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, NULL);
     
     if (!NT_SUCCESS(Status)) {
         ERR("dev_ioctl returned %08x\n", Status);
@@ -4212,53 +4238,16 @@
         return Status;
     }
     
-    to_read = devobj->SectorSize == 0 ? sizeof(superblock) : sector_align(sizeof(superblock), devobj->SectorSize);
-    
-    sb = ExAllocatePoolWithTag(NonPagedPool, to_read, ALLOC_TAG);
-    if (!sb) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    Status = sync_read_phys(Vcb->Vpb->RealDevice, superblock_addrs[0], to_read, (PUCHAR)sb, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("Failed to read superblock: %08x\n", Status);
-        ExFreePool(sb);
-        return Status;
-    }
-    
-    if (sb->magic != BTRFS_MAGIC) {
-        ERR("not a BTRFS volume\n");
-        ExFreePool(sb);
-        return STATUS_WRONG_VOLUME;
-    }
-    
-    if (RtlCompareMemory(&sb->uuid, &Vcb->superblock.uuid, sizeof(BTRFS_UUID)) != sizeof(BTRFS_UUID)) {
-        ERR("different UUIDs\n");
-        ExFreePool(sb);
-        return STATUS_WRONG_VOLUME;
-    }
-    
-    crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
-    TRACE("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
-    
-    if (crc32 != *((UINT32*)sb->checksum)) {
-        ERR("different UUIDs\n");
-        ExFreePool(sb);
-        return STATUS_WRONG_VOLUME;
-    }
-    
-    ExFreePool(sb);
-    
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
     
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
+        superblock* sb;
+        UINT32 crc32;
+        ULONG to_read;
         
         if (dev->removable) {
-            NTSTATUS Status;
-            ULONG cc;
             IO_STATUS_BLOCK iosb;
             
             Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
@@ -4278,6 +4267,44 @@
             dev->change_count = cc;
         }
         
+        to_read = dev->devobj->SectorSize == 0 ? sizeof(superblock) : sector_align(sizeof(superblock), dev->devobj->SectorSize);
+        
+        sb = ExAllocatePoolWithTag(NonPagedPool, to_read, ALLOC_TAG);
+        if (!sb) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        Status = sync_read_phys(dev->devobj, superblock_addrs[0], to_read, (PUCHAR)sb, TRUE);
+        if (!NT_SUCCESS(Status)) {
+            ERR("Failed to read superblock: %08x\n", Status);
+            ExFreePool(sb);
+            return Status;
+        }
+        
+        if (sb->magic != BTRFS_MAGIC) {
+            ERR("not a BTRFS volume\n");
+            ExFreePool(sb);
+            return STATUS_WRONG_VOLUME;
+        }
+        
+        crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
+        TRACE("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
+        
+        if (crc32 != *((UINT32*)sb->checksum)) {
+            ERR("checksum error\n");
+            ExFreePool(sb);
+            return STATUS_WRONG_VOLUME;
+        }
+        
+        if (RtlCompareMemory(&sb->uuid, &Vcb->superblock.uuid, sizeof(BTRFS_UUID)) != sizeof(BTRFS_UUID)) {
+            ERR("different UUIDs\n");
+            ExFreePool(sb);
+            return STATUS_WRONG_VOLUME;
+        }
+        
+        ExFreePool(sb);
+        
         dev->devobj->Flags &= ~DO_VERIFY_VOLUME;
         
         le = le->Flink;
@@ -4302,9 +4329,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_file_system_control(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || (Vcb->type != VCB_TYPE_FS && Vcb->type != VCB_TYPE_CONTROL)) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     Status = STATUS_NOT_IMPLEMENTED;
@@ -4323,13 +4353,13 @@
         case IRP_MN_KERNEL_CALL:
             TRACE("IRP_MN_KERNEL_CALL\n");
             
-            Status = fsctl_request(DeviceObject, Irp, IrpSp->Parameters.FileSystemControl.FsControlCode, FALSE);
+            Status = fsctl_request(DeviceObject, Irp, IrpSp->Parameters.FileSystemControl.FsControlCode);
             break;
             
         case IRP_MN_USER_FS_REQUEST:
             TRACE("IRP_MN_USER_FS_REQUEST\n");
             
-            Status = fsctl_request(DeviceObject, Irp, IrpSp->Parameters.FileSystemControl.FsControlCode, TRUE);
+            Status = fsctl_request(DeviceObject, Irp, IrpSp->Parameters.FileSystemControl.FsControlCode);
             break;
             
         case IRP_MN_VERIFY_VOLUME:
@@ -4351,11 +4381,11 @@
             break;
     }
 
+end:
     Irp->IoStatus.Status = Status;
 
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
     
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
@@ -4375,8 +4405,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_lock_control(DeviceObject, Irp);
+        
+        Irp->IoStatus.Status = Status;
+        IoCompleteRequest(Irp, IO_NO_INCREMENT);
+        
         goto exit;
     }
     
@@ -4395,17 +4429,6 @@
     return Status;
 }
 
-NTSTATUS part0_passthrough(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
-    NTSTATUS Status;
-    part0_device_extension* p0de = DeviceObject->DeviceExtension;
-    
-    IoSkipCurrentIrpStackLocation(Irp);
-    
-    Status = IoCallDriver(p0de->devobj, Irp);
-    
-    return Status;
-}
-
 static NTSTATUS STDCALL drv_shutdown(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     NTSTATUS Status;
     BOOL top_level;
@@ -4417,9 +4440,9 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_shutdown(DeviceObject, Irp);
+        goto end;
     }    
     
     Status = STATUS_SUCCESS;
@@ -4432,17 +4455,103 @@
         uninit(Vcb, TRUE);
     }
     
+#ifdef _DEBUG
+    if (comfo) {
+        ObDereferenceObject(comfo);
+        comdo = NULL;
+        comfo = NULL;
+    }
+#endif
+    
+end:
     Irp->IoStatus.Status = Status;
     Irp->IoStatus.Information = 0;
 
     IoCompleteRequest( Irp, IO_NO_INCREMENT );
 
+    if (top_level) 
+        IoSetTopLevelIrp(NULL);
+    
+    FsRtlExitFileSystem();
+
+    return Status;
+}
+
+static NTSTATUS STDCALL drv_power(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+    NTSTATUS Status;
+    device_extension* Vcb = DeviceObject->DeviceExtension;
+    BOOL top_level;
+
+    FsRtlEnterFileSystem();
+
+    top_level = is_top_level(Irp);
+    
+    Irp->IoStatus.Information = 0;
+    
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_power(DeviceObject, Irp);
+        
+        Irp->IoStatus.Status = Status;
+        IoCompleteRequest(Irp, IO_NO_INCREMENT);
+        
+        goto exit;
+    } else if (Vcb && Vcb->type == VCB_TYPE_FS) {
+        IoSkipCurrentIrpStackLocation(Irp);
+    
+        Status = IoCallDriver(Vcb->Vpb->RealDevice, Irp);
+    
+        goto exit;
+    }
+
+    Status = STATUS_INVALID_DEVICE_REQUEST;
+    Irp->IoStatus.Status = Status;
+    IoCompleteRequest(Irp, IO_NO_INCREMENT);
+    
 exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
     FsRtlExitFileSystem();
+    
+    return Status;
+}
 
+static NTSTATUS STDCALL drv_system_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+    NTSTATUS Status;
+    device_extension* Vcb = DeviceObject->DeviceExtension;
+    BOOL top_level;
+
+    FsRtlEnterFileSystem();
+
+    top_level = is_top_level(Irp);
+    
+    Irp->IoStatus.Information = 0;
+    
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        volume_device_extension* vde = DeviceObject->DeviceExtension;
+
+        IoSkipCurrentIrpStackLocation(Irp);
+    
+        Status = IoCallDriver(vde->pdo, Irp);
+        
+        goto exit;
+    } else if (Vcb && Vcb->type == VCB_TYPE_FS) {
+        IoSkipCurrentIrpStackLocation(Irp);
+    
+        Status = IoCallDriver(Vcb->Vpb->RealDevice, Irp);
+    
+        goto exit;
+    }
+
+    Status = Irp->IoStatus.Status;
+    IoCompleteRequest(Irp, IO_NO_INCREMENT);
+    
+exit:
+    if (top_level) 
+        IoSetTopLevelIrp(NULL);
+    
+    FsRtlExitFileSystem();
+    
     return Status;
 }
 
@@ -4483,11 +4592,9 @@
     rl->thread = PsGetCurrentThread();
     
     while (TRUE) {
-        KIRQL irql;
-        
         locked = FALSE;
         
-        KeAcquireSpinLock(&c->range_locks_spinlock, &irql);
+        ExAcquireResourceExclusiveLite(&c->range_locks_lock, TRUE);
         
         le = c->range_locks.Flink;
         while (le != &c->range_locks) {
@@ -4504,13 +4611,13 @@
         if (!locked) {
             InsertTailList(&c->range_locks, &rl->list_entry);
             
-            KeReleaseSpinLock(&c->range_locks_spinlock, irql);
+            ExReleaseResourceLite(&c->range_locks_lock);
             return;
         }
         
         KeClearEvent(&c->range_locks_event);
         
-        KeReleaseSpinLock(&c->range_locks_spinlock, irql);
+        ExReleaseResourceLite(&c->range_locks_lock);
         
         KeWaitForSingleObject(&c->range_locks_event, UserRequest, KernelMode, FALSE, NULL);
     }
@@ -4517,10 +4624,9 @@
 }
 
 void chunk_unlock_range(device_extension* Vcb, chunk* c, UINT64 start, UINT64 length) {
-    KIRQL irql;
     LIST_ENTRY* le;
     
-    KeAcquireSpinLock(&c->range_locks_spinlock, &irql);
+    ExAcquireResourceExclusiveLite(&c->range_locks_lock, TRUE);
     
     le = c->range_locks.Flink;
     while (le != &c->range_locks) {
@@ -4537,9 +4643,15 @@
     
     KeSetEvent(&c->range_locks_event, 0, FALSE);
     
-    KeReleaseSpinLock(&c->range_locks_spinlock, irql);
+    ExReleaseResourceLite(&c->range_locks_lock);
 }
 
+void log_device_error(device_extension* Vcb, device* dev, int error) {
+    dev->stats[error]++;
+    dev->stats_changed = TRUE;
+    Vcb->stats_changed = TRUE;
+}
+
 #ifdef _DEBUG
 static void STDCALL init_serial() {
     NTSTATUS Status;
@@ -4711,6 +4823,9 @@
             
             if (!PsUpdateDiskCounters)
                 diskacc = FALSE;
+            
+            RtlInitUnicodeString(&name, L"FsRtlUpdateDiskCounters");
+            FsRtlUpdateDiskCounters = (tFsRtlUpdateDiskCounters)MmGetSystemRoutineAddress(&name);
         }
         
         RtlInitUnicodeString(&name, L"CcCopyReadEx");
@@ -4726,6 +4841,7 @@
         CcCopyReadEx = NULL;
         CcCopyWriteEx = NULL;
         CcSetAdditionalCacheAttributesEx = NULL;
+        FsRtlUpdateDiskCounters = NULL;
     }
    
     drvobj = DriverObject;
@@ -4743,15 +4859,17 @@
     DriverObject->MajorFunction[IRP_MJ_FLUSH_BUFFERS]            = (PDRIVER_DISPATCH)drv_flush_buffers;
     DriverObject->MajorFunction[IRP_MJ_QUERY_VOLUME_INFORMATION] = (PDRIVER_DISPATCH)drv_query_volume_information;
     DriverObject->MajorFunction[IRP_MJ_SET_VOLUME_INFORMATION]   = (PDRIVER_DISPATCH)drv_set_volume_information;
-    DriverObject->MajorFunction[IRP_MJ_CLEANUP]                  = (PDRIVER_DISPATCH)drv_cleanup;
     DriverObject->MajorFunction[IRP_MJ_DIRECTORY_CONTROL]        = (PDRIVER_DISPATCH)drv_directory_control;
     DriverObject->MajorFunction[IRP_MJ_FILE_SYSTEM_CONTROL]      = (PDRIVER_DISPATCH)drv_file_system_control;
-    DriverObject->MajorFunction[IRP_MJ_LOCK_CONTROL]             = (PDRIVER_DISPATCH)drv_lock_control;
     DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL]           = (PDRIVER_DISPATCH)drv_device_control;
     DriverObject->MajorFunction[IRP_MJ_SHUTDOWN]                 = (PDRIVER_DISPATCH)drv_shutdown;
-    DriverObject->MajorFunction[IRP_MJ_PNP]                      = (PDRIVER_DISPATCH)drv_pnp;
+    DriverObject->MajorFunction[IRP_MJ_LOCK_CONTROL]             = (PDRIVER_DISPATCH)drv_lock_control;
+    DriverObject->MajorFunction[IRP_MJ_CLEANUP]                  = (PDRIVER_DISPATCH)drv_cleanup;
     DriverObject->MajorFunction[IRP_MJ_QUERY_SECURITY]           = (PDRIVER_DISPATCH)drv_query_security;
     DriverObject->MajorFunction[IRP_MJ_SET_SECURITY]             = (PDRIVER_DISPATCH)drv_set_security;
+    DriverObject->MajorFunction[IRP_MJ_POWER]                    = (PDRIVER_DISPATCH)drv_power;
+    DriverObject->MajorFunction[IRP_MJ_SYSTEM_CONTROL]           = (PDRIVER_DISPATCH)drv_system_control;
+    DriverObject->MajorFunction[IRP_MJ_PNP]                      = (PDRIVER_DISPATCH)drv_pnp;
 
     init_fast_io_dispatch(&DriverObject->FastIoDispatch);
 
@@ -4786,14 +4904,23 @@
         return Status;
     }
 
-    InitializeListHead(&volumes);
-    InitializeListHead(&pnp_disks);
-    
     InitializeListHead(&VcbList);
     ExInitializeResourceLite(&global_loading_lock);
-    ExInitializeResourceLite(&volumes_lock);
+    ExInitializeResourceLite(&volume_list_lock);
     
+    InitializeListHead(&volume_list);
+    
     Status = IoRegisterPlugPlayNotification(EventCategoryDeviceInterfaceChange, PNPNOTIFY_DEVICE_INTERFACE_INCLUDE_EXISTING_INTERFACES,
+                                            (PVOID)&GUID_DEVINTERFACE_VOLUME, DriverObject, volume_notification, DriverObject, &notification_entry2);
+    if (!NT_SUCCESS(Status))
+        ERR("IoRegisterPlugPlayNotification returned %08x\n", Status);
+    
+    Status = IoRegisterPlugPlayNotification(EventCategoryDeviceInterfaceChange, PNPNOTIFY_DEVICE_INTERFACE_INCLUDE_EXISTING_INTERFACES,
+                                            (PVOID)&GUID_DEVINTERFACE_HIDDEN_VOLUME, DriverObject, volume_notification, DriverObject, &notification_entry3);
+    if (!NT_SUCCESS(Status))
+        ERR("IoRegisterPlugPlayNotification returned %08x\n", Status);
+    
+    Status = IoRegisterPlugPlayNotification(EventCategoryDeviceInterfaceChange, PNPNOTIFY_DEVICE_INTERFACE_INCLUDE_EXISTING_INTERFACES,
                                             (PVOID)&GUID_DEVINTERFACE_DISK, DriverObject, pnp_notification, DriverObject, &notification_entry);
     if (!NT_SUCCESS(Status))
         ERR("IoRegisterPlugPlayNotification returned %08x\n", Status);
Index: drivers/filesystems/btrfs/btrfs.h
===================================================================
--- drivers/filesystems/btrfs/btrfs.h	(révision 74430)
+++ drivers/filesystems/btrfs/btrfs.h	(copie de travail)
@@ -495,6 +495,12 @@
     UINT8 reserved[32];
 } BALANCE_ITEM;
 
+#define BTRFS_DEV_STAT_WRITE_ERRORS          0
+#define BTRFS_DEV_STAT_READ_ERRORS           1
+#define BTRFS_DEV_STAT_FLUSH_ERRORS          2
+#define BTRFS_DEV_STAT_CORRUPTION_ERRORS     3
+#define BTRFS_DEV_STAT_GENERATION_ERRORS     4
+
 #pragma pack(pop)
 
 #endif
Index: drivers/filesystems/btrfs/btrfs.rc
===================================================================
--- drivers/filesystems/btrfs/btrfs.rc	(révision 74430)
+++ drivers/filesystems/btrfs/btrfs.rc	(copie de travail)
@@ -70,12 +70,12 @@
         BLOCK "080904b0"
         BEGIN
             VALUE "FileDescription", "WinBtrfs"
-            VALUE "FileVersion", "0.8"
+            VALUE "FileVersion", "0.9"
             VALUE "InternalName", "btrfs"
-            VALUE "LegalCopyright", "Copyright (c) Mark Harmstone 2016"
+            VALUE "LegalCopyright", "Copyright (c) Mark Harmstone 2016-17"
             VALUE "OriginalFilename", "btrfs.sys"
             VALUE "ProductName", "WinBtrfs"
-            VALUE "ProductVersion", "0.8"
+            VALUE "ProductVersion", "0.9"
         END
     END
     BLOCK "VarFileInfo"
